/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.person.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class BerufUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String name;

    public java.lang.String getName(){
      return name;
    }


  public BerufUK(
java.lang.String name
  ) {
    super();


      this.name = name;
      }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((name == null) ? 0 : name.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            BerufUK other = (BerufUK) obj;

                if (name == null) {
          if (other.name != null) {
            return false;
          }
        } else if (!name.equals(other.name)) {
          return false;
        }
        
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return BerufConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(BerufConstants.MESSAGE_KEY_ENTITY_EINZAHL, BerufConstants.MESSAGE_KEY_NAME_EINZAHL, name));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "BerufUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"name="+name
                                    ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(name);
     return list;
   }

            public static <E extends Beruf> java.util.Map<BerufUK, E> mappeBerufNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Beruf::getBerufUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Beruf, BerufUK> getBerufToUKFunction() {
                return Beruf::getBerufUK;
                }

}
